import Control.Concurrent
import Control.Concurrent.Chan
import Control.Exception (finally)

myForkIO :: IO () -> IO (MVar ())
myForkIO io = do
  mvar <- newEmptyMVar
  forkIO (io `finally` putMVar mvar ())
  return mvar

main = do
  ch <- newChan
  t <- myForkIO $ do
    writeChan ch "hello world"
    writeChan ch "hello again"
    writeChan ch "now i quit."
    writeChan ch "wait! One other thing..."
  readChan ch >>= print
  readChan ch >>= print
  readChan ch >>= print
  takeMVar t
