import Control.Concurrent
import Control.Exception (finally)

myForkIO :: IO () -> IO (MVar ())
myForkIO io = do
  mvar <- newEmptyMVar
  forkIO (io `finally` putMVar mvar ())
  return mvar

main = do
  m <- newEmptyMVar
  t <- myForkIO $ do
    v <- takeMVar m
    putStrLn ("received " ++ show v)
  putStrLn "sending"
  putMVar m "wake up!"
  takeMVar t -- wait for thread to terminate
